Skip to content

Latest commit

 

History

History

1340

Folders and files

NameName
Last commit message
Last commit date

parent directory

..
 
 

Given an array of integers arr and an integer d. In one step you can jump from index i to index:

  • i + x where: i + x < arr.length and 0 < x <= d.
  • i - x where: i - x >= 0 and 0 < x <= d.

In addition, you can only jump from index i to index j if arr[i] > arr[j] and arr[i] > arr[k] for all indices k between i and j (More formally min(i, j) < k < max(i, j)).

You can choose any index of the array and start jumping. Return the maximum number of indices you can visit.

Notice that you can not jump outside of the array at any time.

 

Example 1:

Input: arr = [6,4,14,6,8,13,9,7,10,6,12], d = 2
Output: 4
Explanation: You can start at index 10. You can jump 10 --> 8 --> 6 --> 7 as shown.
Note that if you start at index 6 you can only jump to index 7. You cannot jump to index 5 because 13 > 9. You cannot jump to index 4 because index 5 is between index 4 and 6 and 13 > 9.
Similarly You cannot jump from index 3 to index 2 or index 1.

Example 2:

Input: arr = [3,3,3,3,3], d = 3
Output: 1
Explanation: You can start at any index. You always cannot jump to any index.

Example 3:

Input: arr = [7,6,5,4,3,2,1], d = 1
Output: 7
Explanation: Start at index 0. You can visit all the indicies. 

 

Constraints:

  • 1 <= arr.length <= 1000
  • 1 <= arr[i] <= 105
  • 1 <= d <= arr.length

Companies: Facebook, Amazon

Related Topics:
Array, Dynamic Programming, Sorting

Similar Questions:

Solution 1. DFS + Memo

// OJ: https://leetcode.com/problems/jump-game-v/
// Author: github.com/lzl124631x
// Time: O(ND)
// Space: O(N)
class Solution {
public:
    int maxJumps(vector<int>& A, int d) {
        int N = A.size();
        vector<int> cnt(N);
        function<int(int)> dp = [&](int i) {
            if (cnt[i]) return cnt[i];
            int mx = 0;
            for (int j = i - 1, step = 1; step <= d && j >= 0 && A[j] < A[i]; ++step, --j) {
                mx = max(mx, dp(j));
            }
            for (int j = i + 1, step = 1; step <= d && j < N && A[j] < A[i]; ++step, ++j) {
                mx = max(mx, dp(j));
            }
            return cnt[i] = 1 + mx;
        };
        for (int i = 0; i < N; ++i) dp(i);
        return *max_element(begin(cnt), end(cnt));
    }
};

Solution 2. DP + Monotonous Stack

// OJ: https://leetcode.com/problems/jump-game-v/
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(N)
class Solution {
public:
    int maxJumps(vector<int>& A, int d) {
        int N = A.size();
        vector<int> dp(N + 1, 1), left, right;
        A.push_back(INT_MAX);
        for (int i = 0; i <= N; ++i) {
            while (left.size() && A[left.back()] < A[i]) {
                int pre = A[left.back()];
                while (left.size() && A[left.back()] == pre) {
                    int j = left.back();
                    left.pop_back();
                    if (i - j <= d) dp[i] = max(dp[i], dp[j] + 1);
                    right.push_back(j);
                }
                while (right.size()) {
                    int j = right.back();
                    right.pop_back();
                    if (left.size() && j - left.back() <= d) dp[left.back()] = max(dp[left.back()], dp[j] + 1);
                }
            }
            left.push_back(i);
        }
        return *max_element(dp.begin(), dp.end() - 1);
    }
};